% Declare mathematics (so they can be overwritten for PDF)
\gdef \declareMathematics#1#2{\gdef #1{\mathrm{#2}}}
\gdef \declareMathematicsStar#1#2{\gdef #1{\mathop{\mathrm{#2}}}}

% Font styles
\gdef \mcal#1{\mathcal{#1}}

% Sets
\gdef \C{\mathbb{C}}
\gdef \R{\mathbb{R}}
\gdef \Z{\mathbb{Z}}
\gdef \N{\mathbb{N}}

% Basic notation - vectors and random variables 
\gdef \vi#1{\boldsymbol{#1}} %vector or matrix
\gdef \dvi#1{\vi{\dot{#1}}} %differentiated vector or matrix
\gdef \vii#1{\mathbf{#1}} %if \vi doesn't work
\gdef \dvii#1{\vii{\dot{#1}}} %if \dvi doesn't work

\gdef \rnd#1{\mathrm{#1}} %random variable
\gdef \vr#1{\mathbf{\rnd{#1}}} %random vector or matrix
\gdef \dvr#1{\vr{\dot{#1}}} %differentiated vector or matrix

\gdef \vb#1{\pmb{#1}} %#TODO
\gdef \dvb#1{\vb{\dot{#1}}} %#TODO

% Basic notation - general
\gdef \set#1{\left\{#1\right\}}
\gdef \brackets#1{\left( #1 \right)}
\gdef \dom#1{\mcal{D}\, \brackets{#1}}

% Basic notation - general
\gdef \set#1{\left\{#1\right\}}
\gdef \brackets#1{\left( #1 \right)}
\gdef \dom#1{\mcal{D}\, \brackets{#1}}

% Special symbols
\gdef \vf{\varphi}
\gdef \ve{\varepsilon}
\gdef \xx{\vi x}
\gdef \tht{\theta}
\gdef \after{\circ}

% Basic functions
\gdef \absval#1{\left| #1 \right|}
\gdef \id{\mathrm{id}}
\gdef \floor#1{\left\lfloor #1 \right\rfloor}
\gdef \ceil#1{\left\lceil #1 \right\rceil}
\declareMathematics{\im}{im} %image
\declareMathematics{\tg}{tg}
\declareMathematics{\sign}{sign}
\declareMathematics{\card}{card} %cardinality
\declareMathematics{\exp}{exp}
\gdef \indicator#1{\mathbb{I}_{#1}}

% Operators - Analysis
\gdef \hess{\nabla}
\gdef \lagr{\mcal L}
\declareMathematics{\grad}{grad}
\gdef \d{\mathrm{d}}
\gdef \partialDeriv#1#2{\frac {\partial #1} {\partial #2}}
\gdef \partialOp#1{\frac {\partial} {\partial #1}}
\gdef \deriv#1#2{\frac {\d #1} {\d #2}}
\gdef \derivOp#1{\frac {\d} {\d #1}\,}

% Linear algebra
\gdef \norm#1{\left\lVert #1 \right\rVert}
\gdef \scal#1#2{\left\langle #1, #2 \right\rangle}
\gdef \avg#1{\overline{#1}}
\gdef \linspace#1{\mathrm{lin}\set{#1}}

% Linear algebra - Matrices
\gdef \tr{\top}
\gdef \Tr{^\tr}
\gdef \pinv{\dagger}
\gdef \Pinv{^\dagger}
\gdef \ident{\mathbb{I}}
\gdef \mtr#1{\begin{pmatrix}#1\end{pmatrix}}
\gdef \bmtr#1{\begin{bmatrix}#1\end{bmatrix}}

% Statistics
\gdef \noise{\mcal{N}}
\gdef \iid{\overset{\text{iid}}{\sim}}
\gdef \ind{\overset{\text{ind}}{\sim}}
\gdef \condp{\vert}
\gdef \acov{\gamma}
\gdef \acf{\rho}
\gdef \stdev{\sigma}
\declareMathematics{\variance}{var}
\gdef \Variance#1{\variance \brackets{#1}}
\declareMathematics{\cov}{cov}
\declareMathematics{\corr}{cor}
\declareMathematics{\expectedValue}{\mathbb{E}}
\gdef \expect#1{\expectedValue #1}
\gdef \Expect#1{\expectedValue \brackets{#1}}
\gdef \WN#1#2{\mathrm{WN}\brackets{#1,#2}}
\declareMathematics{\uniform}{Unif}
\gdef \att{_t} %at time 
\gdef \predict#1#2#3{\hat {#1}_{#2 | #3}}
\gdef \backs{B}
\gdef \diffEq{\Phi}
\gdef \diff{\Delta}
\gdef \DiffEq#1{\Phi\brackets{#1}}
\gdef \ARmod#1{\mathrm{AR}\brackets{#1}}
\gdef \MAmod#1{\mathrm{MA}\brackets{#1}}
\gdef \ARMA#1#2{\mathrm{ARMA}\brackets{#1, #2}}
\gdef \sARMA#1#2#3{\mathrm{ARMA}\brackets{#1}\brackets{#2}_{#3}}
\gdef \SARIMA#1#2#3{\mathrm{ARIMA}\brackets{#1}\brackets{#2}_{#3}}
\gdef \ARIMA#1#2#3{\mathrm{ARIMA}\brackets{#1, #2, #3}}
\gdef \pacf{\alpha}
\gdef \parcorr#1#2#3{\rho_{#1 #2 | #3}}

\gdef \AIC{\mathrm{AIC}}
\gdef \BIC{\mathrm{BIC}}
\gdef \AICc{\mathrm{AIC}_c}


% Useful commands
\gdef \onTop#1#2{\mathrel{\overset{#2}{#1}}}
\gdef \onBottom#1#2{\mathrel{\underset{#2}{#1}}}
\gdef \tOnTop#1#2{\mathrel{\overset{\text{#2}}{#1}}}
\gdef \EQ{\onTop{=}{!}}
\gdef \isPDef{\onTop{\succ}{?}}

% Game Theory
\gdef \doms{\succ}
\gdef \isdom{\prec}
\gdef \OfOthers#1{_{-#1}}
\gdef \ofOthers{\OfOthers{i}}
\gdef \pdist{\sigma}
\gdef \domGame#1{G_{DS}^{#1}}
\gdef \ratGame#1{G_{Rat}^{#1}}
\gdef \bestRep#1#2{\mathrm{BR}_{#1}\brackets{#2}}
\gdef \perf#1{{#1}_{\mathrm{perf}}}
\gdef \perfG{\perf{G}}
\gdef \imperf#1{{#1}_{\mathrm{imp}}}
\gdef \imperfG{\imperf{G}}
\gdef \proper#1{{#1}_{\mathrm{proper}}}
\gdef \finrep#1#2{{#2}_{#1{\text -}\mathrm{rep}}} %T-stage game
\gdef \infrep#1{#1_{\mathrm{irep}}}
\gdef \repstr{\tau} %strategy in a repeated game
\gdef \emptyhist{\epsilon}
\gdef \extrep#1{{#1^{\mathrm{rep}}}}
\gdef \avgpay#1{#1^{\mathrm{avg}}}

\gdef \succf{\pi} %successor function
\gdef \playf{\rho} %player function
\gdef \actf{\chi} %action function

% Optimization
\declareMathematicsStar{\argmin}{argmin}
\declareMathematicsStar{\argmax}{argmax}
\declareMathematics{\prox}{prox}
\declareMathematics{\loss}{loss}
\declareMathematics{\supp}{supp}
\gdef \Supp#1{\supp\brackets{#1}}
\gdef \Koop{\mcal K}
\gdef \oneToN#1{\left[#1\right]}
\gdef \constraint{\text{s.t.}\;}